/* nc100em, an Amstrad NC100/NC200 emulator.
 * Copyright (C) 1995-2001 Russell Marks and Ian Collier.
 * See common.c for licence details.
 *
 * common.h
 */

extern unsigned char mem[];
extern unsigned char *cardmem;
extern unsigned char *dfile;
extern unsigned char *memptr[];
extern unsigned long tstates,tsmax;
extern int memattr[];
extern volatile int signal_int_flag;
extern volatile int exit_program_flag;
extern int scrn_freq;
extern int default_scale;

extern int card_size;
extern int card_status;
extern int irq_status;
extern int irq_mask;
extern int scrnaddr;
extern int do_nmi;
extern int force_full_redraw;
extern int allow_serial;
extern int write_ram_on_close;
extern int invert_video;

extern unsigned char keyports[];

extern int nc200;
extern int nc150;

#ifdef NC200_DISK_SUPPORT
extern int diskint;
#endif


extern void writeram(unsigned char *x);
extern void writecard(unsigned char *x);
extern unsigned int in(int h,int l);
extern unsigned int out(int h,int l,int a);
extern void common_uninit(void);
extern int serial_input_pending(void);
extern void serout_flush(void);
extern void nc200_fdc_tick(void);
extern void common_init(void);
extern void startsigsandtimer(void);
extern void parseoptions(int argc,char *argv[]);
