/* mc512.c - patch 1024k ZCN memory card image to 512k
 * (based on ZCN's optdir-c.c)
 *
 * usage: mc512 <in.card >out.card
 *
 * Modifies card image, operating as a filter.
 *
 * Must have A:, formatted in ZCN format.
 *
 * Public domain by Russell Marks, 2023-05-30
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


int main(void)
{
/* maybe it's not pretty, but 512k is just nothing at this point */
static unsigned char cardimg[512*1024];

if(isatty(fileno(stdout)))
  fprintf(stderr,"mc512: not writing to tty\n"),exit(1);

/* read input card */
if(fread(cardimg,1,sizeof(cardimg),stdin)!=sizeof(cardimg))
  fprintf(stderr,"mc512: need 512k card as input\n"),exit(1);

if(memcmp(cardimg+2,"ZCN1",4)!=0)
  fprintf(stderr,"mc512: drive A not formatted\n"),exit(1);

/* set card size to 512k */
cardimg[6]=cardimg[256*1024+6]=0;
cardimg[7]=cardimg[256*1024+7]=2;

if(fwrite(cardimg,1,sizeof(cardimg),stdout)!=sizeof(cardimg))
  fprintf(stderr,"mc512: write error\n"),exit(1);

exit(0);
}
